LookingForQuest = CreateFrame("Frame")
LookingForQuest.ChannelNamePvE = "LookingForQuest"
LookingForQuest.ChannelNamePvP = "LookingForQuestPvP"
LookingForQuest.GroupedPlayers = {}
LookingForQuest.HostilePlayers = {}
LookingForQuest.LastQuestQueried = 0
LookingForQuest.CurrentQuestId = 0
LookingForQuest.CurrentQuestName = ""
LookingForQuest.Looking = false
LookingForQuest.BlacklistedQuests = {
"Azerite Wounds",
"Beachhead",
"Critters are Friends, Not Food",
"Dense Storm Silver",
"Keeyo's Champions of Vol'dun",
"Loose Change",
"Make Loh Go",
"Shell Game","Desert Survivors",
"Smooth Platinum",
"Strange Looking Dogs",
"This Little Piggy Has Sharp Tusks",
"Underfoot",
"Vigilant Lookouts"
}
	
local function FilterByChannelName(_,_,_,_,_,channel)
	if string.find(channel, LookingForQuest.ChannelNamePvE) then
		return true
	end
	
	return false
end
	
local function FilterWhispers(_,_,msg)
	if string.find(strlower(msg), "inviting you to a group for the world quest") then
		return true
	end
	
	return false
end
	
local function FilterSystemMessages(_,_,msg)
	if string.find(msg, "is already in a group") and LookingForQuest.Looking then
		local playerName = string.gsub(msg," is already in a group.","")
		table.insert(LookingForQuest.GroupedPlayers, playerName)
		return true
	end
	
	if string.find(strlower(msg), "no player named") and LookingForQuest.Looking then
		local playerName = string.gsub(msg,"No player named '","")
		playerName = string.gsub(playerName,"' is currently playing.","")
		table.insert(LookingForQuest.HostilePlayers, playerName)
		return true
	end
	
	if string.find(strlower(msg), "you aren't in a party") and LookingForQuest.Looking then
		return true
	end
	
	if string.find(strlower(msg), "you have invited") and LookingForQuest.Looking then
		return true
	end
	
	if string.find(strlower(msg), "dungeon difficulty set to") and LookingForQuest.Looking then
		return true
	end
	
	return false
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", FilterByChannelName)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", FilterByChannelName)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", FilterByChannelName)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", FilterByChannelName)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", FilterWhispers)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", FilterWhispers)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", FilterSystemMessages)

hooksecurefunc("ObjectiveTracker_Update", function(reason, questId)
	if LookingForQuest.ShouldAddonBeActive() and questId and not tContains(LookingForQuest.BlacklistedQuests, questId) and LookingForQuest.IsNonEliteWorldQuest(questId) and not (LookingForQuest.CurrentQuestId == questId) then
		LookingForQuest.CurrentQuestId = questId
		local _,_,_,questName = LFGListUtil_GetQuestCategoryData(questId)
		if questName and not LookingForQuest.IsProfessionQuest(questName) and not tContains(LookingForQuest.BlacklistedQuests, questName) and LookingForQuest.PlayerIsLeaderOrSolo() then
			LookingForQuest.CurrentQuestName = questName
			LookingForQuest.LookForGroupDialog(questId, questName)
		end
	end
end)
	
hooksecurefunc("LeaveParty", function()
	LookingForQuest.StopLooking()
end)

LookingForQuest:RegisterEvent("ZONE_CHANGED_NEW_AREA")
LookingForQuest:RegisterEvent("QUEST_TURNED_IN")
LookingForQuest:RegisterEvent("PARTY_INVITE_REQUEST")
LookingForQuest:RegisterEvent("GROUP_JOINED")
LookingForQuest:SetScript("OnEvent", function(self, event, arg1, questId)
	if (event == "ZONE_CHANGED_NEW_AREA") then
		LookingForQuest.StopLooking()
	elseif (event == "QUEST_TURNED_IN") and LookingForQuest.ShouldAddonBeActive() and (arg1 == LookingForQuest.ActiveQuestId) then
		LookingForQuest.StopLooking()
		LookingForQuest.LeavePartyDialog(arg1)
	elseif (event == "PARTY_INVITE_REQUEST") and LookingForQuest.Looking then
		AcceptGroup()
		StaticPopup_Hide("PARTY_INVITE")
	elseif (event == "GROUP_JOINED") and LookingForQuest.Looking then
		StaticPopup_Hide("PARTY_INVITE")
	end
end)

local channelFrame = CreateFrame("Frame")
channelFrame:RegisterEvent("CHAT_MSG_CHANNEL")	
channelFrame:SetScript("OnEvent", function(self, event, message, sender, channel,  ...)
	if string.find(event, "CHAT_MSG_") and LookingForQuest.Looking then
		local playerName = UnitName("PLAYER").."-"..GetRealmName()
		local questNameIndex = string.find(message, "\""..LookingForQuest.ActiveQuestName.."\"")
		if not (sender == playerName) and not (sender == UnitName("PLAYER")) and questNameIndex and LookingForQuest.DoesChannelMatch(channel, LookingForQuest.ActiveQuestId) then
			local foundQuestName = strsub(message,questNameIndex+1)
			local foundQuestNameEnd = string.find(foundQuestName, "\"")
			if foundQuestNameEnd and LookingForGroup.Looking then
				foundQuestName = strsub(foundQuestName,0,foundQuestNameEnd-1)
				LookingForQuest.InviteToGroup(sender, questName)
			end
		end
	end		
end)

function LookingForQuest.LeavePartyDialog(dialogId)			
	if IsInGroup(0) then
		StaticPopupDialogs["Leave"..dialogId] = {
			text = "Do you want to leave the group?",
			button1 = "Yes",
			button2 = "No",
			OnAccept = function()
				LeaveParty()
			end,
			OnCancel = function()
			end,
			timeout = 0,
			whileDead = false,
			hideOnEscape = true,
			preferredIndex = 3,
		}	
		
		StaticPopup_Show("Leave"..dialogId)	
	end
end

function LookingForQuest.IsProfessionQuest(questName)
	if string.find(strlower(questName), "supplies needed") or string.find(strlower(questName), "work order") then
		return true
	end
	
	return false
end

function LookingForQuest.IsNonEliteWorldQuest(questId)
	local _,_,_,_,isElite,_,_ = GetQuestTagInfo(questId)
	if isElite then
		return false
	end

	local i = 1
	while GetQuestLogTitle(i) do
		local _,_,_,_,_,_,_,id,_,_,_,_,isTask,_,_ = GetQuestLogTitle(i)
		if (id == questId) and isTask then
			return true
		end
		
		i = i + 1
	end
	
	return false
end

function LookingForQuest.WipeArrays()
	wipe(LookingForQuest.InvitedPlayers)
	wipe(LookingForQuest.NearbyPlayers)
	wipe(LookingForQuest.ViableTargets)
	wipe(LookingForQuest.GroupedPlayers)
end

function LookingForQuest.StopLooking()
	LookingForQuest.Looking = false
	LookingForQuest.InvitingNearbyPlayers = false
	LookingForQuest.ActiveQuestId = 0
	LookingForQuest.ActiveQuestName = ""
	LookingForQuest.LeaveQuestChannels()
	LookingForQuest.CurrentQuestId = 0
	LookingForQuest.CurrentQuestName = ""
	LookingForQuest.LastInviteSent = GetTime()
	LookingForQuest.WipeArrays()
end

function LookingForQuest.JoinQuestChannel(questId)
	local channelName = LookingForQuest.GetChannelName(questId)
	if GetChannelName(channelName) == 0 then
		JoinChannelByName(channelName)
	end
end

function LookingForQuest.LeaveQuestChannels()
	for i=1,GetNumDisplayChannels() do
		local activeChannelName = GetChannelDisplayInfo(i)
		if string.find(activeChannelName, LookingForQuest.ChannelNamePvE) then
			LeaveChannelByName(activeChannelName)
		end
	end
end

function LookingForQuest.LookForGroupDialog (questId, questName)
	if questName and questId then
		StaticPopupDialogs["LFQ"..questId] = {
			text = string.format("Do you want to find a group for '%s'?", questName),
			button1 = "Yes",
			button2 = "No",
			OnAccept = function()
				LookingForQuest.LookForGroup(questId, questName)
			end,
			OnCancel = function()
				table.insert(LookingForQuest.BlacklistedQuests, questId)
			end,
			timeout = 0,
			whileDead = false,
			hideOnEscape = true,
			preferredIndex = 3,
		}
		
		if not (LookingForQuest.LastQuestQueried == questId) then
			StaticPopup_Show("LFQ"..questId)
		end
	end
end

function LookingForQuest.GetChannelName(questId)
	if C_PvP.IsWarModeActive() then
		return LookingForQuest.ChannelNamePvP..questId
	elseif not C_PvP.IsWarModeActive() then
		return LookingForQuest.ChannelNamePvE..questId
	end	
end

function LookingForQuest.LookForGroup(questId, questName)
	LookingForQuest.LastQuestQueried = questId
	LookingForQuest.InvitingNearbyPlayers = true	
	LookingForQuest.JoinQuestChannel(questId)
	LookingForQuest.Looking = true
	LookingForQuest.ActiveQuestId = questId
	LookingForQuest.ActiveQuestName = questName
	LookingForQuest.WipeArrays()

	local index = GetChannelName(LookingForQuest.GetChannelName(questId))
	if (index ~= nil) and not LookingForQuest.IsAzeriteQuest(questName) then
		SendChatMessage(string.format("Looking for group for the world quest \"%s\".", questName) , "CHANNEL", nil, index)
	end	
end

function LookingForQuest.DoesChannelMatch(channel, questId)
	if (string.find(channel, LookingForQuest.GetChannelName(questId))) then
		return true
	end
	
	return false
end

function LookingForQuest.IsAzeriteQuest(questName)
	if (questName == "Azerite Empowerment") or (questName == "Azerite Wounds") or (questName == "Azerite Madness") or (questName == "Azerite Mining") then
		return true
	end
	
	return false
end