LookingForQuest.ViableTargets = {}
LookingForQuest.NearbyPlayers = {}
LookingForQuest.BlacklistedNearbyQuests = {
"Cargo Reclamation"
}

local function IsFriendly(flags)
	if bit.band(flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then
		return true
	end
	
	return false
end

local function IsNeutral(flags)
	if bit.band(flags, COMBATLOG_OBJECT_REACTION_NEUTRAL) > 0 then
		return true
	end
	
	return false
end

local function IsHostile(flags)
	if bit.band(flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
		return true
	end
	
	return false
end

local function TargetIsViable(unitName, targetName, targetGuid, targetFlags)
	if targetGuid and string.find(targetGuid, "Creature-") and targetName and (targetName ~= unitName) and IsHostile(targetFlags) and not tContains(LookingForQuest.ViableTargets, targetName) then
		if LookingForQuest.UnitIsInParty(unitName) or (unitName == UnitName("player")) then
			return true
		end
	end
	
	return false
end

local function UnitIsOtherPlayer(unitName, unitGuid, unitFlags)
	if unitGuid and string.find(unitGuid, "Player-") and GetPlayerInfoByGUID(unitGuid) and (unitName ~= UnitName("player")) and not IsHostile(unitFlags) then
		return true
	end
	
	return false
end

local function InviteNearybyPlayers()
	for playerName, time in pairs(LookingForQuest.NearbyPlayers) do
		local timeSinceLastInvite = GetTime() - LookingForQuest.LastInviteSent
		local timeSincePlayerWasSeen = GetTime() - time
		if (timeSincePlayerWasSeen < 30) and (timeSinceLastInvite > 10) and LookingForQuest.InvitingNearbyPlayers then
			LookingForQuest.InviteToGroup(playerName, LookingForQuest.ActiveQuestName)
		end
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:SetScript("OnEvent", function(self, event, arg1, questID, arg3)
	if LookingForQuest.ShouldAddonBeActive() then		
		local _,_,unitHiding,unitGuid,unitName,unitFlags,_,targetGuid,targetName,targetFlags = CombatLogGetCurrentEventInfo()		
		if not unitHiding then
			if TargetIsViable(unitName, targetName, targetGuid, targetFlags) then
				table.insert(LookingForQuest.ViableTargets, targetName)
			end
			
			if UnitIsOtherPlayer(unitName, unitGuid, unitFlags) and tContains(LookingForQuest.ViableTargets, targetName) then
				LookingForQuest.NearbyPlayers[unitName] = GetTime()
			end	
				
			if LookingForQuest.PlayerIsLeaderOrSolo() and LookingForQuest.InvitingNearbyPlayers and not LookingForQuest.IsSingleBossQuest(LookingForQuest.ActiveQuestId) and not tContains(LookingForQuest.BlacklistedNearbyQuests, LookingForQuest.ActiveQuestName) then
				InviteNearybyPlayers()
			end
		end
	end
end)