LookingForQuest.InvitedPlayers = {}
LookingForQuest.InvitingNearbyPlayers = false
LookingForQuest.ActiveQuestId = 0
LookingForQuest.ActiveQuestName = ""
LookingForQuest.LastInviteSent = GetTime()

function LookingForQuest.PlayerIsLeaderOrSolo()
	if not IsInGroup(0) or UnitIsGroupLeader("player") then
		return true
	end
	
	return false
end

function LookingForQuest.IsSingleBossQuest(questId)
	if (GetQuestObjectiveInfo(questId,2,true) == nil) then
		local objectiveText = GetQuestObjectiveInfo(questId,1,true)
		if (objectiveText) then
			if string.find(objectiveText, "1/1") or string.find(objectiveText, "0/1") then
				if string.find(strlower(objectiveText), "slain") or string.find(strlower(objectiveText), "defeated") then
					return true
				end
			end
		end
	end
	
	return false
end

function LookingForQuest.PlayerInvitedAlready(playerName)
	for invitedPlayer, time in pairs (LookingForQuest.InvitedPlayers) do
		if (invitedPlayer == playerName) then
			return true
		end
	end
	
	return false
end

function LookingForQuest.UnitIsAlreadyGrouped(playerName)
	return false
end

function LookingForQuest.ShouldAddonBeActive()
	if not IsInInstance() then
		return true
	end
	
	return false
end

function LookingForQuest.UnitIsInParty(unitName)
	if GetHomePartyInfo() then 
		for index,groupMemberName in pairs(GetHomePartyInfo()) do	
			if (unitName == groupMemberName) then
				return true
			end
		end
	end
	
	return false
end

function LookingForQuest.InviteToGroup(unit, questName)
	if LookingForQuest.PlayerIsLeaderOrSolo() and unit and not LookingForQuest.UnitIsInParty(unit) and not LookingForQuest.UnitIsAlreadyGrouped(unit) and not LookingForQuest.PlayerInvitedAlready(unit) and (GetNumGroupMembers() < 5) then
		LookingForQuest.InvitedPlayers[unit] = GetTime()
		LookingForQuest.LastInviteSent = GetTime()
		InviteUnit(unit)
		LookingForQuest.SendWhisper(unit, questName)
	end
end

function LookingForQuest.SendWhisper(unit, questName)
	C_Timer.After(1, function()
		if not tContains(LookingForQuest.GroupedPlayers, unit) and not tContains(LookingForQuest.HostilePlayers, unit) then
			SendSystemMessage(string.format("Sending party invite to %s.", unit))
			SendChatMessage(string.format("Inviting you to a group for the world quest %s.", questName) , "WHISPER", nil, unit)
		end
	end)
end